#ifndef PARSE_UNION_H
#define PARSE_UNION_H

#include"expr.h"
#include"ast.h"

typedef struct parse_union_t {
char cval;
int ival;
Symbol symbol;
Num number;

Ast::Decls decls;
Ast::Proc_decl proc_decl;
Ast::Var_decls var_decls;
Ast::Type_decl type_decl;
//Ast::Init_decl init_decl;

Ty ty;
Ty_list ty_list;
Ast::Symbol_list symbol_list;

Ast::Sequence sequence;
Ast::Stmt stmt;
Ast::SStmt sstmt;
Ast::SStmts sstmts;
Ast::Step step;
Ast::Opts opts;
Ast::Opt opt;
Ast::Body body;

Varref varref;
Ast::Varspec_list varspec_list;
Ast::Varspec varspec;
Var_dcl vardcl;
Ast::Expr_list expr_list;
Expr* expr;
Send_args send_args;
Recv_args recv_args;
Recv_arg recv_arg;
   
Const constant;
//Ast::Run_step_list run_step_list;
//Ast::Run_step run_step;
} parse_union ;

#define YYSTYPE parse_union

#endif
