#include<iostream>
#include<sstream>
#include"cfg.h"
#include"sys_state.h"



ostream& operator << (ostream& os, const Node& n) {os << n.to_str(); return os;}

string Node::to_str() const { return string("["+Util::to_str(id)+"]");}
//template<class N>
//string Edge<N>::to_str() const{ return string("-- "+ lab +" ->");}
//string Edge<CFG_node>::to_str() const{ return string("-- "+ lab +" ->");}
ostream& operator << (ostream& os, const CFG& cfg) {os << cfg.to_str(); return os;}

string CFG::to_str() const {
    ostringstream oss;
    oss << "CFG "<<id <<": [\n";
    oss << "(entry, exit) : (" << entry_node << "," << exit_node << ")\n";
    oss << Graph<CFG_node,CFG_edge>::to_str_const(); 
    oss << "]\n";
    return oss.str();
}



//------ System ------//
ostream& operator << (ostream& os, const Sys_state& st) {os << st.to_str(); return os;}

