#ifndef _TYS_H_
#define _TYS_H_
#include"basic_vals.h"

enum bTy {BitTy, BoolTy, ByteTy, IntTy, EvTy, ChanTy,  PidTy, ShortTy, UnsignedTy};
typedef Symbol NamedTy;
typedef Num BvTy;
typedef TUP::tuple<bTy, int> ArrayTy;
typedef VAR::variant<bTy, NamedTy, BvTy, ArrayTy> Ty;
typedef list<Ty> Ty_list;


bool is_ty_chan(const Ty& ty);
bool is_ty_ev(const Ty& ty);
bool is_ty_bv(const Ty& ty);
void get_ty_values(const Ty& ty, list<Const>& clist);
int get_ty_size(const Ty& ty);
string ty2yices_str(const Ty& ty);
string ty2str(const Ty& ty);
//bool operator < (const Ty& ty1, const Ty& ty2) ;

#endif
