#include"val.h"
#include"util.h"
#include"ops.h"

const Val_xx_int Val_xx_int::ValX = Val_xx_int();
const tbool tbool::tboolX = tbool();

Val_xx_int Val_xx_int::operator - ()  const {
    if (is_int()) return -i;
    else return ValX;
    
}
Val_xx_int Val_xx_int::operator ! ()  const {
    if (is_int()) return !i;
    else return ValX;
    
}


Val_xx_int Val_xx_int::operator + (const Val_xx_int& v) const {
    if (is_int() && v.is_int() )
        return i+v.i;
    else return ValX;
    
}
Val_xx_int Val_xx_int::operator - (const Val_xx_int& v) const {
    if (is_int() && v.is_int() )
     return i-v.i;
    else return ValX;
    
}

Val_xx_int Val_xx_int::operator * (const Val_xx_int& v) const {
    if (is_int() && v.is_int() )
     return i*v.i;
    else return ValX;
    
}

Val_xx_int Val_xx_int::operator / (const Val_xx_int& v) const { 
    if (is_int() && v.is_int() )
     return i/v.i; 
    else return ValX;
    
}

Val_xx_int Val_xx_int::operator ^ (const Val_xx_int& v) const {
    if (is_int() && v.is_int() )
    return i^v.i;
    else return ValX;
    
}
Val_xx_int Val_xx_int::operator % (const Val_xx_int& v) const {
    if (is_int() && v.is_int() )
    return i%v.i;
    else return ValX;
    
}

Val_xx_int Val_xx_int::operator | (const Val_xx_int& v) const {
    if (is_int() && v.is_int() )
    return i|v.i;
    else return ValX;
    
}
Val_xx_int Val_xx_int::operator & (const Val_xx_int& v) const {
    if (is_int() && v.is_int() )
    return i&v.i;
    else return ValX;
    
}

tbool Val_xx_int::operator == (const Val_xx_int& v) const {
    if (is_int() && v.is_int() )
        return i == v.i;
    else return tbool::tboolX;
    
}
tbool Val_xx_int::operator != (const Val_xx_int& v) const {
    if (is_int() && v.is_int() )
        return i != v.i;
    else return tbool::tboolX;
    
}
tbool Val_xx_int::operator < (const Val_xx_int& v) const {
    if (is_int() && v.is_int() )
        return i < v.i;
    else return tbool::tboolX;
}
tbool Val_xx_int::operator > (const Val_xx_int& v) const {
    if (is_int() && v.is_int() )
    return i > v.i;
    else return tbool::tboolX;
}
tbool Val_xx_int::operator <= (const Val_xx_int& v) const {
    if (is_int() && v.is_int() )
    return i <= v.i;
    else return tbool::tboolX;
}
tbool Val_xx_int::operator >= (const Val_xx_int& v) const {
    if (is_int() && v.is_int() )
    return i >= v.i;
    else return tbool::tboolX;
}

tbool Val_xx_int::operator && (const Val_xx_int& v) const {
    if (is_int() && v.is_int() )
    return i && v.i;
    //else if (is_int() && i==0) return l_false;
    else return tbool::tboolX;
}
tbool Val_xx_int::operator || (const Val_xx_int& v) const {
    if (is_int() && v.is_int() )
    return i || v.i;
    else return tbool::tboolX;
}
Val_xx_int Val_xx_int::operator >> (const Val_xx_int& v) const {
    if (is_int() && v.is_int() )
    return i >> v.i;
    else return tbool::tboolX;
}
Val_xx_int Val_xx_int::operator << (const Val_xx_int& v) const {
    if (is_int() && v.is_int() )
    return i << v.i;
    else return tbool::tboolX;
}

string Val_xx_int::to_str() const { 
    if (is_int() ) return int2str(i);
    else return "X";
}

bool Val_xx_int::is_int() const { return get_type() == INT; }
int Val_xx_int::to_int() const { CHK(is_int()); return i;}


bool Val_xx_int::is_t() const {
//    CHK (is_int() );
 //   return !(is_f()); 
  if ( is_int() ) return i != 0;
  else return false;
}
bool Val_xx_int::is_f() const { 
    if( is_int() ) return i == 0; 
    else return false;
}
