ifndef $(NATIVE)
NATIVE = 1
endif

ifndef $(FACILITIES)
FACILITIES = 1
endif

ifeq ($(NATIVE),1)
ifeq ($(FACILITIES), 0)
fail:
	@echo "Error: Native compilation does not work with ocaml 3.08.4";
endif
endif


ifeq ($(FACILITIES),1)
    OCAMLDIR = /usr/local/lib/ocaml-3.08.3 
    OCAMLBIN = /usr/local/bin
else
    OCAMLDIR = /usr1/nishants/local/lib/ocaml
    OCAMLBIN = /usr1/nishants/local/bin
endif
OCAMLLIB = $(OCAMLDIR)
OCAMLINC = $(OCAMLDIR)

ifeq ($(NATIVE), 1)
    OCAMLC = $(OCAMLBIN)/ocamlopt.opt 
    CMA = cmxa
    CMO = cmx
    CAMLRUN = asmrun
else
    OCAMLC = $(OCAMLBIN)/ocamlc.opt -custom
    CMA = cma
    CMO = cmo
    CAMLRUN = camlrun
endif

FOCI = /usr1/nishants/symoda/foci
FOCILIB = $(FOCI)/lib

INCS+=-I $(FOCI)/include -I $(OCAMLINC)
LDFLAGS+=-L $(FOCILIB) -L $(OCAMLLIB)
LDDEPS+= -lfoci -Wl,-\( -lfocicxx -l$(CAMLRUN) -Wl,-\) -lcfoci -lstr -lnums -ldl -lunix 
#-Wl,-\( -lfocicxx -Wl,-\) 
OCAMLCFLAGS=-I $(FOCI)/include
