
#ifndef EECS_H
#define EECS_H

#include"expr.h"
#include"cfg.h"
//#include"val.h"
//#include"sys_state.h"
#include"dp.h"



template<class DP>
void DP_declare_varrefs ( DP& dp, const set<Varref>& vrs, Pid pid, int depth) ;
template<class DP>
void DP_declare_varrefs_ext ( DP& dp, const set<Varref>& vrs, Pid pid, int add_depth) ;


template<class DP>
typename DP::expr eval_name_expr(DP& dp, const Var_dcl& vd, Pid pid, int depth) ;
template<class DP>
typename DP::expr eval_sym_expr(DP& dp, const Expr* e, int pid, int depth) ;
template<class DP>
typename DP::expr eval_sym_expr_pair(DP& dp, const Expr* e, int pid, int depth) ;

//for Guard_expr = list<Expr*>
template<class DP>
typename DP::expr eval_guard_expr(DP& dp, const Guard_expr& gexpr, Pid pid, int depth) ;
//for list<Assign>
template<class DP>
typename DP::expr eval_sym_alist ( DP& dp, const list<Assign>& alist, Pid pid, int depth) ;
//--------------------------- Expr -----------------------------------

#endif
