#include"sys_state.h"

bool Mem_map::is_vd_st_var ( Pid pid, const Var_dcl& vd ) const {
    CHK( Key_In_Bag(pid, pid2stvars) );
    const Var_dcls& vds = pid2stvars.find(pid)->second;
    bool ret = (Key_In_Bag(vd,vds));
    if ( !ret ) {
        //Util::msg(2,"var "+vd.to_str() + " not found in pid2stvars, pid ="+ int2str(pid));
    }
    return ret;
    
   // return true;
}

bool Sys_state_diff::add(const Sys_state_diff& s_diff, Upd_mode U) { 
    if( mem == NULL ) mem = s_diff.mem;
    else {
        if ( mem != s_diff.mem ) {
//            Util::msg(5, "my str: "  + to_str() + "\n");
  //          Util::msg(5, "other's str: " + s_diff.to_str() + "\n");
            CHK(0);
        }
    }
    bool ret, retall=true;

    ret = ps_diff.add(s_diff.ps_diff,U);
    if ( !ret ) retall = false; 

    ret = gs_diff.add(s_diff.gs_diff,U);
    if ( !ret ) retall= false; 
    
    ret = cfas_diff.add(s_diff.cfas_diff,U);
    if ( !ret ) retall= false; 

    ret = prs_diff.add(s_diff.prs_diff,U);
    if ( !ret ) retall= false; 

    /*if( !retall) {
            Util::msg(2, "my str: "  + to_str() + "\n");
            Util::msg(2, "other's str: " + s_diff.to_str() + "\n");

    }*/

    return retall;
}


void Sys_state_diff::abstract_to_globals ( Sys_state_diff& sd) const {
    CHK( mem != NULL );
   // CHK( mem == sd.mem ); //probably will not hold; but since gs_diff map is always same, so does not matter
    //TODO: handle ps_diff
    //ps_diff.project_to(sd.ps_diff);
    sd.ps_diff.clear();
    sd.cfas_diff.clear() ;
    sd.prs_diff.clear();
    gs_diff.project_to(sd.gs_diff);
}

