#ifndef _VAL_H_
#define _VAL_H_

#include<string>
using namespace std;


/*
enum T { INT, NONE};
T t;

Val operator + (const Val& v) {
 T t1 = t; T t2 = v.t;
 if( t == INT and t2==INT) { this->to_int() + v.to_int();}
 else 
}
 */

struct tbool {//tri bool
    enum bool_val {T,F,X};
    bool_val v;

    static const tbool tboolX;
    
    tbool() { v = X;}
    tbool( bool b ) { if(b) v=T; else v=F; }
    bool is_t() { return v==T; }
    bool is_f() { return v==F; }
    bool is_x() { return v==X; }

};

struct Val_int  {
    enum vty {INT, NONE};
    vty ty;
    int i;

    Val_int() : ty(INT), i(0) {} //remove i(0) when consider NONE
    Val_int(int _i) : ty(INT), i(_i) {}

    Val_int operator - ()  const;
    Val_int operator ! ()  const;

    Val_int operator + (const Val_int& v)  const;
    Val_int operator - (const Val_int& v)  const;
    Val_int operator * (const Val_int& v)  const;
    Val_int operator / (const Val_int& v)  const;
    Val_int operator ^ (const Val_int& v)  const;
    Val_int operator % (const Val_int& v)  const;

    Val_int operator | (const Val_int& v)  const;
    Val_int operator & (const Val_int& v)  const;
    Val_int operator << (const Val_int& v) const;
    Val_int operator >> (const Val_int& v) const;

    bool operator == (const Val_int& v) const;
    bool operator != (const Val_int& v) const;
    bool operator < (const Val_int& v) const;
    bool operator > (const Val_int& v) const;
    bool operator <= (const Val_int& v) const;
    bool operator >= (const Val_int& v) const;
    bool operator && (const Val_int& v) const;
    bool operator || (const Val_int& v) const;

    bool is_t() const;
    bool is_f() const;

    bool is_int() const;
    string to_str() const;
    int to_int() const;

    vty get_type() const { return ty;}

};



struct Val_x_int  {
    enum vty {INT, NONE};
    vty ty;
    int i;

    static const Val_x_int ValX;

    Val_x_int() : ty(NONE) {} //remove i(0) when consider NONE
    Val_x_int(int _i) : ty(INT), i(_i) {}

    Val_x_int operator - ()  const;
    Val_x_int operator ! ()  const;

    Val_x_int operator + (const Val_x_int& v)  const;
    Val_x_int operator - (const Val_x_int& v)  const;
    Val_x_int operator * (const Val_x_int& v)  const;
    Val_x_int operator / (const Val_x_int& v)  const;
    Val_x_int operator ^ (const Val_x_int& v)  const;
    Val_x_int operator % (const Val_x_int& v)  const;

    Val_x_int operator | (const Val_x_int& v)  const;
    Val_x_int operator & (const Val_x_int& v)  const;
    Val_x_int operator << (const Val_x_int& v) const;
    Val_x_int operator >> (const Val_x_int& v) const;

    bool operator == (const Val_x_int& v) const;
    bool operator != (const Val_x_int& v) const;
    bool operator < (const Val_x_int& v) const;
    bool operator > (const Val_x_int& v) const;
    bool operator <= (const Val_x_int& v) const;
    bool operator >= (const Val_x_int& v) const;
    bool operator && (const Val_x_int& v) const;
    bool operator || (const Val_x_int& v) const;

    bool is_t() const;
    bool is_f() const;

    bool is_int() const;
    string to_str() const;
    int to_int() const;

    vty get_type() const { return ty;}
    bool is_x() const { 
        if ( get_type() == NONE ) return true;
        else return false;
    }

};

struct Val_xx_int  {
    enum vty {INT, NONE};
    vty ty;
    int i;

    static const Val_xx_int ValX;

    Val_xx_int() : ty(NONE) {} //remove i(0) when consider NONE
    Val_xx_int(int _i) : ty(INT), i(_i) {}
    Val_xx_int(tbool tb)  {
        if (tb.is_x()) { ty = NONE;}
        else { ty = INT; i = tb.is_t()?1:0;}
    }

    Val_xx_int operator - ()  const;
    Val_xx_int operator ! ()  const;

    Val_xx_int operator + (const Val_xx_int& v)  const;
    Val_xx_int operator - (const Val_xx_int& v)  const;
    Val_xx_int operator * (const Val_xx_int& v)  const;
    Val_xx_int operator / (const Val_xx_int& v)  const;
    Val_xx_int operator ^ (const Val_xx_int& v)  const;
    Val_xx_int operator % (const Val_xx_int& v)  const;

    Val_xx_int operator | (const Val_xx_int& v)  const;
    Val_xx_int operator & (const Val_xx_int& v)  const;
    Val_xx_int operator << (const Val_xx_int& v) const;
    Val_xx_int operator >> (const Val_xx_int& v) const;

    tbool operator == (const Val_xx_int& v) const;
    tbool operator != (const Val_xx_int& v) const;
    tbool operator < (const Val_xx_int& v) const;
    tbool operator > (const Val_xx_int& v) const;
    tbool operator <= (const Val_xx_int& v) const;
    tbool operator >= (const Val_xx_int& v) const;
    tbool operator && (const Val_xx_int& v) const;
    tbool operator || (const Val_xx_int& v) const;

    bool is_t() const;
    bool is_f() const;

    bool is_int() const;
    string to_str() const;
    int to_int() const;

    vty get_type() const { return ty;}
    bool is_x() const { 
        if ( get_type() == NONE ) return true;
        else return false;
    }

};
typedef Val_xx_int Val;
#endif
