#include"val.h"
#include"util.h"
#include"ops.h"

Val_int Val_int::operator - ()  const {return -i;}
Val_int Val_int::operator ! ()  const {return !i;}


Val_int Val_int::operator + (const Val_int& v) const {return i+v.i;}
Val_int Val_int::operator - (const Val_int& v) const {return i-v.i;}
Val_int Val_int::operator * (const Val_int& v) const {return i*v.i;}
Val_int Val_int::operator / (const Val_int& v) const { return i/v.i; }
Val_int Val_int::operator ^ (const Val_int& v) const {
    return i^v.i;
}
Val_int Val_int::operator % (const Val_int& v) const {
    return i%v.i;
}

Val_int Val_int::operator | (const Val_int& v) const {
    return i|v.i;
}
Val_int Val_int::operator & (const Val_int& v) const {
    return i&v.i;
}

bool Val_int::operator == (const Val_int& v) const {
    return i == v.i;
}
bool Val_int::operator != (const Val_int& v) const {
    return i != v.i;
}
bool Val_int::operator < (const Val_int& v) const {
    return i < v.i;
}
bool Val_int::operator > (const Val_int& v) const {
    return i > v.i;
}
bool Val_int::operator <= (const Val_int& v) const {
    return i <= v.i;
}
bool Val_int::operator >= (const Val_int& v) const {
    return i >= v.i;
}

bool Val_int::operator && (const Val_int& v) const {
    return i && v.i;
}
bool Val_int::operator || (const Val_int& v) const {
    return i || v.i;
}
Val_int Val_int::operator >> (const Val_int& v) const {
    return i >> v.i;
}
Val_int Val_int::operator << (const Val_int& v) const {
    return i << v.i;
}

string Val_int::to_str() const { return int2str(i);}

bool Val_int::is_int() const { return get_type() == INT; }
int Val_int::to_int() const { CHK(is_int()); return i;}


bool Val_int::is_t() const { return !(is_f()); }
bool Val_int::is_f() const { CHK(is_int()); return i == 0; }
